﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr137_1
{
    // Класс со свойством: 
    class MyClass {
        // Закрытые целочисленные поля: 
        private int tekNum; // Текущий номер элемента
        private int kol; // Количество элементов массива 
        private int[] mas; // Массив
        // Конструктор с двумя аргументами: 
        public MyClass(int[] t) {
            // Присваивание значения полям:
            tekNum = 0;
            kol = t.Length;
            mas = t;
        }
        // Описание целочисленного свойства: 
        public int code{
            // Метод вызывается при считывании значения свойства: 
            get{
                // Значение свойства:
                int t = mas[tekNum]; // Определяем значение текущего элемента
                tekNum = ++tekNum % kol; // Вычисляем следующий номер
                return t; // Возвращаем значение текущего элемента
            }
            // Метод вызывается при присваивании
            // значения свойству:
            set{
                mas[tekNum] = value; // Меняем значение текущего элемента
            }
        }
    }

    // Класс с главным методом:
    class Program
    {
        static void Main()
        {
            // Создание и инициализация массива:
            int[] nums = { 1, 3, 5, 7, 6, 5, 4 };
            // Создание объекта:
            MyClass obj = new MyClass(nums);
            // Проверка содержимого объекта:
            Console.WriteLine("10 раз вывели свойство code: ");
            for (int i = 0; i < 10; i++)
                Console.WriteLine(obj.code);
            Console.WriteLine("Присвоили свойству code значение -7.");
            obj.code = -7;
            Console.WriteLine("10 раз вывели свойство code: ");
            for (int i = 0; i < 10; i++)
                Console.WriteLine(obj.code);
            // Задержка:
            Console.ReadLine();
        }
    }
}
